/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the JoinColumnRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &JoinColumnRequest{}

// JoinColumnRequest struct for JoinColumnRequest
type JoinColumnRequest struct {
	Source *string `json:"source,omitempty"`
	Column *string `json:"column,omitempty"`
	As     *string `json:"as,omitempty"`
}

// NewJoinColumnRequest instantiates a new JoinColumnRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewJoinColumnRequest() *JoinColumnRequest {
	this := JoinColumnRequest{}
	return &this
}

// NewJoinColumnRequestWithDefaults instantiates a new JoinColumnRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewJoinColumnRequestWithDefaults() *JoinColumnRequest {
	this := JoinColumnRequest{}
	return &this
}

// GetSource returns the Source field value if set, zero value otherwise.
func (o *JoinColumnRequest) GetSource() string {
	if o == nil || IsNil(o.Source) {
		var ret string
		return ret
	}
	return *o.Source
}

// GetSourceOk returns a tuple with the Source field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *JoinColumnRequest) GetSourceOk() (*string, bool) {
	if o == nil || IsNil(o.Source) {
		return nil, false
	}
	return o.Source, true
}

// HasSource returns a boolean if a field has been set.
func (o *JoinColumnRequest) HasSource() bool {
	if o != nil && !IsNil(o.Source) {
		return true
	}

	return false
}

// SetSource gets a reference to the given string and assigns it to the Source field.
func (o *JoinColumnRequest) SetSource(v string) {
	o.Source = &v
}

// GetColumn returns the Column field value if set, zero value otherwise.
func (o *JoinColumnRequest) GetColumn() string {
	if o == nil || IsNil(o.Column) {
		var ret string
		return ret
	}
	return *o.Column
}

// GetColumnOk returns a tuple with the Column field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *JoinColumnRequest) GetColumnOk() (*string, bool) {
	if o == nil || IsNil(o.Column) {
		return nil, false
	}
	return o.Column, true
}

// HasColumn returns a boolean if a field has been set.
func (o *JoinColumnRequest) HasColumn() bool {
	if o != nil && !IsNil(o.Column) {
		return true
	}

	return false
}

// SetColumn gets a reference to the given string and assigns it to the Column field.
func (o *JoinColumnRequest) SetColumn(v string) {
	o.Column = &v
}

// GetAs returns the As field value if set, zero value otherwise.
func (o *JoinColumnRequest) GetAs() string {
	if o == nil || IsNil(o.As) {
		var ret string
		return ret
	}
	return *o.As
}

// GetAsOk returns a tuple with the As field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *JoinColumnRequest) GetAsOk() (*string, bool) {
	if o == nil || IsNil(o.As) {
		return nil, false
	}
	return o.As, true
}

// HasAs returns a boolean if a field has been set.
func (o *JoinColumnRequest) HasAs() bool {
	if o != nil && !IsNil(o.As) {
		return true
	}

	return false
}

// SetAs gets a reference to the given string and assigns it to the As field.
func (o *JoinColumnRequest) SetAs(v string) {
	o.As = &v
}

func (o JoinColumnRequest) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o JoinColumnRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Source) {
		toSerialize["source"] = o.Source
	}
	if !IsNil(o.Column) {
		toSerialize["column"] = o.Column
	}
	if !IsNil(o.As) {
		toSerialize["as"] = o.As
	}
	return toSerialize, nil
}

type NullableJoinColumnRequest struct {
	value *JoinColumnRequest
	isSet bool
}

func (v NullableJoinColumnRequest) Get() *JoinColumnRequest {
	return v.value
}

func (v *NullableJoinColumnRequest) Set(val *JoinColumnRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableJoinColumnRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableJoinColumnRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableJoinColumnRequest(val *JoinColumnRequest) *NullableJoinColumnRequest {
	return &NullableJoinColumnRequest{value: val, isSet: true}
}

func (v NullableJoinColumnRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableJoinColumnRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
